/**********************************************************************

This file is part of the Quantum Computation Language QCL.

(c) Copyright by Bernhard Oemer <oemer@tph.tuwien.ac.at>, 1998

This program comes without any warranty; without even the implied 
warranty of merchantability or fitness for any particular purpose.

     This program is free software under the terms of the 
     GNU General Public Licence (GPL) version 2 or higher

************************************************************************/


#include "syntax.h"
#include "symbols.h"
#include "error.h"
#include "yacc.h"
#include "quheap.h"
#include "parse.h"
#include "options.h"
#include "debug.h"

#include <stdio.h>
#include <unistd.h>
#include <getopt.h>

extern char *optarg;
extern int optind;
extern struct msgstruct *message;

int main(int argc,char **argv) {
  string s;
  int i;
  SymTab gl;
  SymTab loc;
  tError err;

  initialize_readline();
  parseopt(argc,argv);
  QuHeap qh(optBits);
  err.settrace(optTrace); 

  if(!optNoDefaultInclude) qclfile(DEF_STD_INCLUDE,&loc,&gl,&qh,0,&err);
  for(i=optind;i<argc;i++) qclfile(argv[i],&loc,&gl,&qh,0,&err,DB_ERROR);
  if(optInteractive) qclshell(&loc,&gl,&qh,0,&err,DB_NORMAL);
  if(optLogfile) qcl_delete(optLogfile);
  cout << message->end_session;
  exit(0);
}


